import 'package:dart_hydrologis_db/dart_hydrologis_db.dart';
import 'package:dart_jts/dart_jts.dart';
import 'package:flutter_geopackage/flutter_geopackage.dart';
import 'package:test/test.dart';

ADb createDb(Function? onCreateFunction) {
  var db = SqliteDb(
      "/storage/lavori_tmp/INRETE/2023_inserimenti_pre_ricerca/Database_RFP_Forlì_Pifferi_primo_passaggio/dataindex_v6_2022.sqlite");
  db.open(populateFunction: onCreateFunction);
  return db;
}

var t = TableName("gpspoints", schemaSupported: false);
void main() {
  test('test creation', () {
    var db = createDb(null);

    expect(true, db.hasTable(t));
    var tableColumns = db.getTableColumns(t);
    expect(33, tableColumns.length);

    db.close();
  });
  test('test select', () {
    var db = createDb(null);

    var select = db.select("select lat, lon, the_geom from gpspoints limit 1");
    var row = select.first;

    var geom = row.get('the_geom');

    var geometry = WKBReader().read(geom, doSpatialite: true);

    expect(geometry is Point, true);

    db.close();
  });
}
